/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// SmartToken struct for SmartToken
type SmartToken struct {
	// Name of token mechanism (smart contract)
	Type string `json:"type"`
	// Address of contract
	Contract string `json:"contract"`
}

// NewSmartToken instantiates a new SmartToken object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSmartToken(type_ string, contract string) *SmartToken {
	this := SmartToken{}
	this.Type = type_
	this.Contract = contract
	return &this
}

// NewSmartTokenWithDefaults instantiates a new SmartToken object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSmartTokenWithDefaults() *SmartToken {
	this := SmartToken{}
	return &this
}

// GetType returns the Type field value
func (o *SmartToken) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *SmartToken) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *SmartToken) SetType(v string) {
	o.Type = v
}

// GetContract returns the Contract field value
func (o *SmartToken) GetContract() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Contract
}

// GetContractOk returns a tuple with the Contract field value
// and a boolean to check if the value has been set.
func (o *SmartToken) GetContractOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Contract, true
}

// SetContract sets field value
func (o *SmartToken) SetContract(v string) {
	o.Contract = v
}

func (o SmartToken) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["type"] = o.Type
	}
	if true {
		toSerialize["contract"] = o.Contract
	}
	return json.Marshal(toSerialize)
}

type NullableSmartToken struct {
	value *SmartToken
	isSet bool
}

func (v NullableSmartToken) Get() *SmartToken {
	return v.value
}

func (v *NullableSmartToken) Set(val *SmartToken) {
	v.value = val
	v.isSet = true
}

func (v NullableSmartToken) IsSet() bool {
	return v.isSet
}

func (v *NullableSmartToken) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSmartToken(val *SmartToken) *NullableSmartToken {
	return &NullableSmartToken{value: val, isSet: true}
}

func (v NullableSmartToken) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSmartToken) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
